'****************************************************************************
'
' Spam-Proxy   : SPAMPRXY.INC (Include File)
' Version      : 0.20
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Last Files at: http://www.gohel.de
' Last Updates : see directly in the sources
'
'****************************************************************************

GLOBAL Version             AS STRING      ' Versionsangabe
GLOBAL Author              AS STRING      ' Compilation by ...
GLOBAL CrLf                AS STRING      ' CrLf (DOS oder Unix Style)
GLOBAL Lf                  AS STRING      ' Lf (fr Spoolfiles)
GLOBAL Eol                 AS STRING      ' End Of Line (Cr/LF - 13/10)
GLOBAL hLogFile            AS LONG        ' Handle fr Logfile
GLOBAL sLogApp             AS STRING      ' ID der Appliaktion
GLOBAL AppPath             AS STRING      ' Pfad zu UKAW
GLOBAL Mutex_Io            AS LONG        ' Freefile/Open Mutex um Handle Problem zu umgehen
GLOBAL Mutex_Accept        AS LONG        ' Zugriffs-Mutex fr eintreffende Connects
GLOBAL Mutex_Dupe          AS LONG        ' Zugriffs-Mutex fr Dupebase-String
GLOBAL Mutex_Log           AS LONG        ' Zugriffs-Mutex fr Logfile
GLOBAL Mutex_Cs            AS LONG        ' Zugriffs-Mutex fr CrossSecretary
GLOBAL CS                  AS LONG        '

DECLARE FUNCTION Get_IpAdress(BYVAL hTcp AS LONG) AS STRING
DECLARE FUNCTION Get_DateHeader() AS STRING
DECLARE FUNCTION Get_DayName(BYVAL Day AS INTEGER) AS STRING
DECLARE FUNCTION Get_MonthName(BYVAL Month AS INTEGER) AS STRING
DECLARE FUNCTION Get_Timezone() AS STRING
DECLARE FUNCTION Get_Qp2Text(BYVAL TEXT AS STRING) AS STRING
DECLARE FUNCTION Get_XP_Adress(BYVAL MailFrom AS STRING) AS STRING
DECLARE FUNCTION Get_NC_Adress(BYVAL MailFrom AS STRING) AS STRING
DECLARE FUNCTION Get_Configuration(BYVAL BfgFile AS STRING, BYVAL Thread_Id AS LONG) AS LONG
DECLARE FUNCTION Get_CfgLine(BYVAL Cfg AS STRING, BYVAL Match AS STRING, BYVAL CfgDefault AS STRING, BYVAL XP AS LONG) AS STRING
DECLARE FUNCTION Get_CfgEntry(BYVAL Cfg AS STRING, BYVAL Match AS STRING, BYVAL CfgDefault AS STRING, BYVAL XP AS LONG) AS STRING
DECLARE FUNCTION Get_CfgFlag(BYVAL Cfg AS STRING) AS LONG

DECLARE FUNCTION FileOpen(hFile AS LONG, BYVAL sFile AS STRING, BYVAL Thread_ID AS LONG) AS LONG

'-------------------------------------------------------------------------------------------
' From-Zeile im CrossPoint-Style erzeugen
'-------------------------------------------------------------------------------------------
FUNCTION Get_XP_Adress(BYVAL a AS STRING) AS STRING

        LOCAL MailFrom     AS STRING      ' MailFrom
        LOCAL RealName     AS STRING      ' RealName (sofern vorhanden)
        LOCAL p1           AS INTEGER     '
        LOCAL p2           AS INTEGER

        ON ERROR GOTO Get_XP_AdressError

        a$ = TRIM$(a$)                    ' eventuelle Space entfernen

        p1% = INSTR(1, a$, "<")
        IF p1% > 0 THEN                                   ' alternate from: Style
            MailFrom$ = TRIM$(MID$(a$, p1% + 1, 255))     ' "Real Name"  <a@b.com>
            REPLACE ">" WITH "" IN MailFrom$
            IF p1% > 1 THEN
                RealName$ = " (" + TRIM$(MID$(a$, 1, p1% - 1)) + ")"
                REPLACE CHR$(34) WITH "" IN RealName$
            END IF
        ELSE
             MailFrom$ = PARSE$(a$, " ", 1)               ' CrossPoint Style
             p2% = INSTR(1, a$, " ")                      ' a@b.com (Real Name)
             IF p2% > 0 THEN
                 RealName$ = " (" + MID$(a$, p2% + 2)
             END IF
        END IF
        Get_XP_Adress = MailFrom$ + RealName$
        EXIT FUNCTION

Get_XP_AdressError:
        FUNCTION = a$
END FUNCTION

'-------------------------------------------------------------------------------------------
' From-Zeile im Netscape-Style erzeugen
'-------------------------------------------------------------------------------------------
FUNCTION Get_NC_Adress(BYVAL a AS STRING) AS STRING

        LOCAL MailFrom     AS STRING      ' MailFrom
        LOCAL RealName     AS STRING      ' RealName (sofern vorhanden)
        LOCAL p1           AS INTEGER     '
        LOCAL p2           AS INTEGER

        ON ERROR GOTO Get_NC_AdressError

        a$ = TRIM$(a$)                    ' eventuelle Space entfernen

        p1% = INSTR(1, a$, "<")
        IF p1% > 0 THEN                                   ' alternate from: Style
            MailFrom$ = TRIM$(MID$(a$, p1% + 1, 255))     ' "Real Name"  <a@b.com>
            REPLACE ">" WITH "" IN MailFrom$
            IF p1% > 1 THEN
                RealName$ = TRIM$(MID$(a$, 1, p1% - 1)) + " "
                REPLACE CHR$(34) WITH "" IN RealName$
            END IF
        ELSE
             MailFrom$ = PARSE$(a$, " ", 1)               ' CrossPoint Style
             p2% = INSTR(1, a$, " ")                      ' a@b.com (Real Name)
             IF p2% > 0 THEN
                 RealName$ = MID$(a$, p2% + 2) + " "
                 REPLACE ")" WITH "" IN RealName$
             END IF
        END IF
        Get_NC_Adress = RealName$ + "<" + MailFrom$ + ">"
        EXIT FUNCTION

Get_NC_AdressError:
        FUNCTION = a$
END FUNCTION

'-------------------------------------------------------------------------------------------
' Date: Zeile erzeugen
'-------------------------------------------------------------------------------------------
FUNCTION Get_DateHeader() AS STRING

        LOCAL Year         AS STRING
        LOCAL Month        AS INTEGER
        LOCAL Day          AS INTEGER
        LOCAL DayName      AS STRING
        LOCAL sMonth       AS STRING
        LOCAL SystemDatum   AS SYSTEMTIME

        GetLocalTime SystemDatum

        Month% = VAL(MID$(DATE$, 1, 2))
        Day%   = VAL(MID$(DATE$, 4, 2))
        Year$  = MID$(DATE$ ,7, 4)
        FUNCTION = "Date: " + Get_DayName(SystemDatum.wDayOfWeek) + ", " + FORMAT$(Day%, "00") + _
                   " " + Get_MonthName(Month%) + " " + Year$ + " " + TIME$ + Get_Timezone$

END FUNCTION


'-------------------------------------------------------------------------------------------
' Tagessstring holen
'-------------------------------------------------------------------------------------------
FUNCTION Get_DayName(BYVAL Day AS INTEGER) AS STRING

        ' Schade das Windows immer die deutschen Tage nutzt
        SELECT CASE Day
            CASE 0: FUNCTION = "Sun"
            CASE 1: FUNCTION = "Mon"
            CASE 2: FUNCTION = "Tue"
            CASE 3: FUNCTION = "Wed"
            CASE 4: FUNCTION = "Thu"
            CASE 5: FUNCTION = "Fri"
            CASE 6: FUNCTION = "Sat"
        END SELECT
END FUNCTION

'-------------------------------------------------------------------------------------------
' Monatsstring holen
'-------------------------------------------------------------------------------------------
FUNCTION Get_MonthName(BYVAL Month AS INTEGER) AS STRING
        SELECT CASE Month
            CASE  1: FUNCTION = "Jan"
            CASE  2: FUNCTION = "Feb"
            CASE  3: FUNCTION = "Mar"
            CASE  4: FUNCTION = "Apr"
            CASE  5: FUNCTION = "May"
            CASE  6: FUNCTION = "Jun"
            CASE  7: FUNCTION = "Jul"
            CASE  8: FUNCTION = "Aug"
            CASE  9: FUNCTION = "Sep"
            CASE 10: FUNCTION = "Oct"
            CASE 11: FUNCTION = "Nov"
            CASE 12: FUNCTION = "Dec"
        END SELECT
END FUNCTION

'-------------------------------------------------------------------------------------------
' Zeitzone holen
'-------------------------------------------------------------------------------------------
FUNCTION Get_Timezone() AS STRING

        LOCAL Bias          AS LONG       '
        LOCAL Zone          AS STRING     '
        LOCAL TimeZone      AS TIME_ZONE_INFORMATION

        ON ERROR RESUME NEXT

        ' Zeitzonenfeld berechnen
        SELECT CASE GetTimeZoneInformation(TimeZone)
            ' Standard bzw. Winterzeit
            CASE %TIME_ZONE_ID_STANDARD
                Bias = TimeZone.Bias
            ' Sommerzeit
            CASE %TIME_ZONE_ID_DAYLIGHT
                Bias = TimeZone.Bias + TimeZone.DaylightBias
            CASE ELSE
                Bias = 0
        END SELECT
        IF Bias < 0 THEN
            Bias = ABS(Bias)
            Zone = "+"
        ELSE
            Zone = "-"
        END IF
        Bias = (Bias \ 60) * 100 + (Bias MOD 60)
        FUNCTION = " " & Zone$ & FORMAT$(Bias, "0000")

END FUNCTION

'-------------------------------------------------------------------------------------------
' FileOpen, sauberes File ffnen in Multithreading-Umgebung
'-------------------------------------------------------------------------------------------
FUNCTION FileOpen(hFile AS LONG, BYVAL sFile AS STRING, BYVAL Thread_ID AS LONG) AS LONG

        ON ERROR RESUME NEXT

        WaitForSingleObject Mutex_Io, %INFINITE
        hFile = FREEFILE
        OPEN sFile FOR BINARY LOCK WRITE AS #hFile
        IF FILEATTR(hFile, 2) = 0 THEN
            hFile = -1
            FUNCTION = %False
            'Logwrite "Error (" + TRIM$(STR$(ERR)) + ") Opening " + sFile, Thread_Id, %LogState_OtherError
        ELSE
            FUNCTION = %True
        END IF
        Releasemutex Mutex_Io

END FUNCTION


'-------------------------------------------------------------------------------------------
' MediaPlay
'-------------------------------------------------------------------------------------------

SUB MediaPlay(Wavfile AS ASCIIZ)

        LOCAL DirData  AS WIN32_FIND_DATA
        LOCAL hDir         AS LONG        ' Handle der Win32 DIR$ Funktionn

        ON ERROR RESUME NEXT

        ' auf WAV-File checken
        hDir = FindFirstFile(Wavfile, DirData)
        IF hDir > -1 THEN
            SndPlaySound WavFile, %SND_ASYNC
        END IF
        FindClose hDir

END SUB
